#!/bin/bash
#This script is not only for column generation, it does that only when it is run with a second argument

#parameters: file, column, scale divider
calcAverage()
{
    vals=`cut $1 -d "&" -f $2`
    sum=0
    count=0
    for a in $vals
    do 
        sum=$(($sum+$a))
        count=$(($count+1))
    done
    if [ $count -gt 0 ]; then
        echo `bc<<< "scale=4;${sum}/(${count}*$3)"`
    else
        echo " -1 "
    fi
}
texBlock()
{
    noScale=1
    scale=1000

    col1=$2
    col2=$(calcAverage $1 2 $noScale)
    col3=$(calcAverage $1 3 $noScale)
    col4=$(calcAverage $1 4 $scale)
    col5=$(calcAverage $1 5 $noScale)
    col6=$(calcAverage $1 6 $noScale)
    col7=$(calcAverage $1 7 $scale)
    printf "%25s %6.2f($%4.1f$)/$%6.2f$ &%6.2f($%4.1f$) &$%6.2f" $col1 $col2 $col3 $col4 $col5 $col6 $col7
    vals=`cut $1 -d "&" -f 5|wc -w`
    lines=`cat $1| wc -l`
    if [ $vals -ne $lines ]
    then 
        diff=$(($lines-$vals))
        printf "%5s" "^{$diff}" 
    else
        printf "     "
    fi
    printf "$  \n"
}
texBlockCG()
{
    noScale=1
    scale=1000

    col1=$2
    col2=$(calcAverage $1 2 $noScale)
    col3=$(calcAverage $1 3 $scale)
    col4=$(calcAverage $1 4 $noScale)
    col5=$(calcAverage $1 5 $scale)
    printf "%25s%6.2f/$%6.2f$ &%6.2f/$%6.2f" $col1 $col2 $col3 $col4 $col5 
    vals=`cut $1 -d "&" -f 5|wc -w`
    lines=`cat $1| wc -l`
    if [ $vals -ne $lines ]
    then 
        diff=$(($lines-$vals))
        printf "%5s" "^{$diff}" 
    else
        printf "     "
    fi
    printf "$  \n"

}
#texBlockCG test.tex TMP
#exit
if [ "$#" -eq 0 ]
then 
    echo "Please give me an input file name"
    exit
fi
if [ "$#" -eq 1 ]
then 
    makeCmd="make cutstock"
    runCmd="./cutstock"
    texSummaryCmd="texBlock"
fi
if [ "$#" -eq 2 ]
then 
    makeCmd="make cgCutStock"
    runCmd="./mainCG"
    texSummaryCmd="texBlockCG"
fi
instancePath=$1
instanceFile=`basename $instancePath`

echo "Compiling the main program for application on $instancePath" 
makeOut=`$makeCmd`
if [ $? -gt 0 ]; then
    echo $makeOut
    echo "Please solve the compilation problems first."
    exit
fi


month=`date "+%Y-%m"`
today=`date "+%Y-%m-%d-%Hh%M.%S"`
outDir=output/cstock$month/$today$instanceFile
mkdir -p $outDir
echo "Archiving sources"
tar -czvf $outDir/src.tgz colgensrc/* src/* Makefile  &>/dev/null

cout="$outDir/cout.txt"
clog="/dev/null"
cerr="/dev/null"
echo "**************************************************************************************************************"
echo "Today is ${today}. All output in ${cout}, ${cerr} and ${clog}. Running:"
`$runCmd $1 $clog 2>$cerr >$cout`
$texSummaryCmd $cout $instanceFile >> $outDir/block.tex
cat $cout
echo ""
cat $outDir/block.tex

