//ATTENTION: this file should be always included first by any .cpp file (or .h if necessary).
//Typically this config file has platform related configuration data, project-wide constants and
//macros, parameters, etc.
#ifndef CONFIG_H_INCLUDED
#define CONFIG_H_INCLUDED
//For numerical approximations
#define RC_EPS 1.0e-6


/*You can trace the calling point of print messages with lines below*/
//ATTENTION: put it after all includes of a file, otherwise it can be active in std header files
//#define cout cout<<__FILE__<<":"<<__LINE__<<":"
//#define cerr cerr<<__FILE__<<":"<<__LINE__<<":"

/* Useful Tweaks: You can remove all asserts (and other checks) with line bellow, but attention to any -DNDEBUG in the MAKEFILE */
//#define NDEBUG

//STR macro below if USEFUL for writing MACRO DEFINITIONS into result files
#define STR_EXPAND(tok) #tok
#define STR(tok) STR_EXPAND(tok)


/********************************************************************************************/
/********************************************************************************************/
//     This part deals with "long" data type that seem too short (as short as int), which is ok
//     according to the standards, see generic.cpp now
/********************************************************************************************/

//I understand "long long" means __int64 by default in window: I am not sure this is necessary
//for using the non-standard type "long long"
//#ifdef WIN32
//  #define unsigned_long_long unsigned __int64
//  #define long_long __int64
//#else // gcc. Might not work on other compilers!
//  #define unsigned_long_long unsigned long long
//  #define long_long long long
//#endif

#endif
