#ifndef SUBPROB_H_INCLUDED
#define SUBPROB_H_INCLUDED

namespace problemSpecific{

//return value: 0 when there is nothing more to load, 1 otherwise
//return implicit: number of variables n,
//                 lower bound on each variable l
//                 upper bound on each variable u
//                 objective function coefficients b
//                 objective function base, a constant to be added to the obj func value
//Other *problem-specific* data is loaded in: problemSpecific::w and problemSpecific::C
int loadData(char *filename, int &n, double* &l, double* &u, double* &b, double &lBndBase);

//input: integer ray direction r (an array)
//return value: normally 1, \ie, new pattern (facet found); 0 means unbounded problem in direction r
//other returns: 
//              t\geq 0: maximum value such that a\cdot r\in P
//              a      : the pattern (facet) reached by going in direction r
//                       - it can be NULL if a stopping (time) condition is reached in the subproblem 
//              ca     : right hand side of above pattern
//              p      : the profit of the pattern, ie, t=ca/p
void irmSubproblem(int * r, double &t, int * &a, double &ca, int & p);

// Put any other subproblem function you need in a different private header!

}
#endif
